diff --git a/gcc/m2/gm2-compiler/M2SymInit.mod b/gcc/m2/gm2-compiler/M2SymInit.mod
index deca342f73f..2bc15d3bd0a 100644
--- a/gcc/m2/gm2-compiler/M2SymInit.mod
+++ b/gcc/m2/gm2-compiler/M2SymInit.mod
@@ -61,7 +61,7 @@ FROM SymbolTable IMPORT NulSym, ModeOfAddr, IsVar, IsRecord, GetSType,
                         IsReallyPointer, IsUnbounded,
                         IsVarient, IsFieldVarient, GetVarient,
                         IsVarArrayRef, GetSymName,
-                        IsType, IsPointer,
+                        IsType, IsPointer, IsTuple,
                         GetParameterShadowVar, IsParameter, GetLType,
                         GetParameterHeapVar, GetVarDeclTok ;
 
@@ -1165,6 +1165,21 @@ BEGIN
 END CheckRecordField ;
 
 
+(*
+   CheckLastForIterator -
+*)
+
+PROCEDURE CheckLastForIterator (op1tok: CARDINAL; op1: CARDINAL;
+                                op2tok: CARDINAL; op2: CARDINAL;
+                                warning: BOOLEAN; i: CARDINAL) ;
+BEGIN
+   SetVarInitialized (op1, FALSE, op1tok) ;
+   Assert (IsTuple (op2)) ;
+   CheckDeferredRecordAccess (op2tok, GetNth (op2, 1), FALSE, warning, i) ;
+   CheckDeferredRecordAccess (op2tok, GetNth (op2, 2), FALSE, warning, i) ;
+END CheckLastForIterator ;
+
+
 (*
    CheckBecomes -
 *)
@@ -1282,6 +1297,9 @@ BEGIN
    IfLessEquOp,
    IfGreOp,
    IfGreEquOp        : CheckComparison (op1tok, op1, op2tok, op2, warning, i) |
+   LastForIteratorOp : CheckLastForIterator (op1tok, op1, op2tok, op2,
+                                             warning, i) ;
+                       Assert (IsConst (op3)) |
    TryOp,
    ReturnOp,
    CallOp,
diff --git a/gcc/m2/gm2-compiler/P2SymBuild.mod b/gcc/m2/gm2-compiler/P2SymBuild.mod
index d51fd1c931a..70492705129 100644
--- a/gcc/m2/gm2-compiler/P2SymBuild.mod
+++ b/gcc/m2/gm2-compiler/P2SymBuild.mod
@@ -153,7 +153,7 @@ FROM M2Comp IMPORT CompilingDefinitionModule,
                    CompilingProgramModule ;
 
 FROM M2Const IMPORT constType ;
-FROM M2Students IMPORT CheckForVariableThatLooksLikeKeyword ;
+FROM M2Students IMPORT CheckVariableAgainstKeyword ;
 IMPORT M2Error ;
 
 
@@ -1177,7 +1177,7 @@ BEGIN
    PopT (n) ;
    i := 1 ;
    WHILE i <= n DO
-      CheckForVariableThatLooksLikeKeyword (OperandT (n+1-i)) ;
+      CheckVariableAgainstKeyword (OperandT (n+1-i)) ;
       tok := OperandTok (n+1-i) ;
       Var := MakeVar (tok, OperandT (n+1-i)) ;
       AtAddress := OperandA (n+1-i) ;
diff --git a/gcc/testsuite/gm2/iso/fail/forloopbyvar.mod b/gcc/testsuite/gm2/iso/fail/forloopbyvar.mod
new file mode 100644
index 00000000000..4198d74f608
--- /dev/null
+++ b/gcc/testsuite/gm2/iso/fail/forloopbyvar.mod
@@ -0,0 +1,16 @@
+MODULE forloopbyvar ;
+
+
+PROCEDURE foo ;
+VAR
+   i, n: CARDINAL ;
+   s   : CARDINAL ;
+BEGIN
+   s := 1 ;
+   FOR i := 1 TO 10 BY s DO
+   END
+END foo ;
+
+BEGIN
+   foo
+END forloopbyvar.
diff --git a/gcc/testsuite/gm2/iso/fail/forloopbyvar4.mod b/gcc/testsuite/gm2/iso/fail/forloopbyvar4.mod
new file mode 100644
index 00000000000..241e3530262
--- /dev/null
+++ b/gcc/testsuite/gm2/iso/fail/forloopbyvar4.mod
@@ -0,0 +1,17 @@
+MODULE forloopbyvar4 ;
+
+PROCEDURE TestFor (boolarray: ARRAY OF BOOLEAN);
+VAR
+   k, m: CARDINAL ;
+BEGIN
+   k := 4 ;
+   FOR m := k * k TO HIGH (boolarray) BY k DO
+      boolarray[m] := FALSE;
+   END
+END TestFor ;
+
+VAR
+   boolarray: ARRAY [1..1024] OF BOOLEAN ;
+BEGIN
+   TestFor (boolarray)
+END forloopbyvar4.
diff --git a/gcc/testsuite/gm2/iso/fail/forloopbyvar5.mod b/gcc/testsuite/gm2/iso/fail/forloopbyvar5.mod
new file mode 100644
index 00000000000..28b881ff190
--- /dev/null
+++ b/gcc/testsuite/gm2/iso/fail/forloopbyvar5.mod
@@ -0,0 +1,17 @@
+MODULE forloopbyvar5 ;
+
+PROCEDURE TestFor (boolarray: ARRAY OF BOOLEAN);
+VAR
+   k, m: CARDINAL ;
+BEGIN
+   k := 4 ;
+   FOR m := k * k TO HIGH (boolarray) BY k*3 DO
+      boolarray[m] := FALSE;
+   END
+END TestFor ;
+
+VAR
+   boolarray: ARRAY [1..1024] OF BOOLEAN ;
+BEGIN
+   TestFor (boolarray)
+END forloopbyvar5.
diff --git a/gcc/testsuite/gm2/iso/pass/forloopbyvar3.mod b/gcc/testsuite/gm2/iso/pass/forloopbyvar3.mod
new file mode 100644
index 00000000000..d6064a67986
--- /dev/null
+++ b/gcc/testsuite/gm2/iso/pass/forloopbyvar3.mod
@@ -0,0 +1,16 @@
+MODULE forloopbyvar3 ;
+
+PROCEDURE TestFor (boolarray: ARRAY OF BOOLEAN);
+VAR
+   m: CARDINAL ;
+BEGIN
+   FOR m := HIGH (boolarray) TO 2 BY -2 DO
+      boolarray[m] := FALSE;
+   END
+END TestFor ;
+
+VAR
+   boolarray: ARRAY [1..1024] OF BOOLEAN ;
+BEGIN
+   TestFor (boolarray)
+END forloopbyvar3.

